	page	,132
	title	Encode XPL programs using only ASCII
HOOKS = 1	;set to 1 to put in debugging "hooks"
;
MINBUF = 2
;
USEI3HOOK = 0
;
hookcode macro
IF USEI3HOOK
	int	3
ELSE
	nop
endIF
	ret
	endm
;
doparm1 macro
	endm
doparm2 macro
	endm
doparm3 macro
	endm
dovars	macro
	endm
doread	macro
	endm
;
dowrite macro
	call	crc32out
	endm
;
include inout.inc
;
t = (offset s0+8000h-$) mod 16
IF t
	db	t dup(0)
endIF
;
QUOTEPFX equ	11
TILDEPFX equ	10
EXCLAIMPFX_OR_FOXFOXPFX equ	9
;
SEMICLN equ	8
COLON	equ	7
USCORE	equ	6
PASSBYTE equ	5
SKIPBYTE equ	4
CMNTEND equ	3
EMBEDEND equ	2
EMBEDST equ	1
;		0 1 2 3 4 5 6 7 8 9 A B C D E F
ctbl	db	5,5,5,5,5,5,5,5,5,4,3,5,5,3,5,5  ;00 000 tab LF CR
	db	5,5,5,5,5,5,5,5,5,5,4,5,5,5,5,5  ;10 016
	db	4,9,5,5,5,4,5,11,5,5,5,5,5,5,5,5 ;20 032 SP !  %  '
	db	5,5,5,5,5,5,5,5,5,5,7,8,5,5,5,5  ;30 048 :  ;
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;40 064
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6  ;50 080 _
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;60 096
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5 ;70 112 ~
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;80 128
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;90 144
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,2  ;A0 160 guillemets
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;B0 176
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;C0 192
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;D0 208
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5  ;E0 224
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,9  ;F0 240
;
include xyverbs.inc
;
baseb	equ	this byte
basew	equ	this word
;
;For reduced instruction size, we set BP to point at baseb/basew, and
;we use instructions of the form
;	mov	word ptr ss:(pend3w-base1)[bp],cx (894E02h,3 bytes)
;instead of
;	mov	word ptr cs:pend3w,cx	     (2E890Exxxxh, 5 bytes)
;for most references to the variables below
;
;exclaimb and exclaimn hold data passed by an '!' packet
exclaimw equ	this word
exclaimb db	0	;'b' data (1 byte)
exclaimn db	0	;'n' data (2 bits)
;
pend3w	equ	this word
pend3ex db	0	;NZ: exclaim modifier info pending
pend3	db	0	;1: ":" pfx pending, 2: ";" pfx pending
;
crc32tk dw	0,0	;CRC32 token value
crc32d	dw	0,0	;CRC32 accumulator
crc32dw dw	0	;did write already switch
crc32sw db	0	;doing CRC32 switch
crc32err db	0	;CRC32 error switch
;
;a nonzero 'skipctl' value indicates we are in a comment and should
;discard data. A left guillemet increments skipctl by 2, and a right
;guillemet decrements it by 2. A "'%" ORs bit 7 on, and a CR or LF ANDs
;bit 7 off.
skipctl db	0	;nonzero means discard input
;
;'simple "input data error" flag, to cause msg at end of program. Data to
;actually locate error is emitted in output, bracketed by "[[[[ ]]]]"
errflag db	0	;nonzero indicates error
;
donex:	jmp	done
;left guillemet
is1:	add	byte ptr ss:(skipctl-baseb)[bp],2
	jmp	short skip1
;right guillemet
is2:	sub	byte ptr ss:(skipctl-baseb)[bp],2
	jnb	skip1
	add	byte ptr ss:(skipctl-baseb)[bp],2
	jmp	short skip1
;CR or LF
is3:	and	byte ptr ss:(skipctl-baseb)[bp],0FEh
	jmp	short skip1
;skipping a comment. Still have to watch for 0FFh encapsulations
cmtskp: cmp	al,0FFh ;0FFh encapsulation?
	jne	skip1	;jmp if not
	mov	bl,3	;need 3 bytes input
	call	rfshchk
	jc	rdwr
	add	si,bx	;skip 2 bytes or what's left
	sub	cx,bx
	jmp	short skip1
;
expand1:mov	bl,3	;need 3 bytes output space to expand
	call	rfshchk
	jc	rdwr
	sub	cx,bx
expand2:call	expandx ;expand byte in AL to 3 byte code
	jmp	short skip1
;
rdwr:	call	stdrw
	mov	bp,offset baseb-offset s0
	jcxz	donex
mainloop:lodsb
	mov	bl,al
	mov	bl,cs:ctbl[bx]
	dec	bx
	jz	is1	;left guillemet (1)
	dec	bx
	jz	is2	;right guilemet (2)
	dec	bx
	jz	is3	;CR,LF		(3)
	dec	bx
	jz	skip1	;tab, sp, '%'	(4)
	cmp	byte ptr ss:(skipctl-baseb)[bp],ah
	jne	cmtskp	;jmp if skipping comment
	dec	bx
	jnz	not5	;jmp if not simple char to pass
put1a:	cmp	byte ptr ss:(pend3-baseb)[bp],ah
	jnz	expand1 ;jmp if expand pending
putj:	mov	byte ptr ss:(pend3ex-baseb)[bp],ah
	stosb
skip1:	loop	mainloop
	jmp	short rdwr
;
;not simple pass 1 char case
;
not5:	dec	bx
	jnz	not6
;underscore
	mov	al,' '
	jmp	short put1a
;
not6:	dec	bx
	jnz	not7
;colon
	mov	byte ptr ss:(pend3-baseb)[bp],1
	jmp	skip1
;
not7:	dec	bx
	jnz	not8
;semicolon
	mov	byte ptr ss:(pend3-baseb)[bp],2
	jmp	skip1
;
;now getting to cases that require more input or output
;make sure 4 bytes out available, and 4 bytes in available
;unless near EOF on input (CX<4 will indicate)
;
not8:	xchg	bx,ax
	mov	bl,4	;max in: 4 (~ddd), max out 3
	call	rfshchk
rdwrx:	jc	rdwr
	cmp	cx,2	;need at least 2 input chars in all cases
	jnb	got2in
needinp:mov	al,cl
	jmp	short dataerr
;
;return info, cases: exclaim, tilde, quote, foxfox
;  bad input:
;    carry set, SI at 2nd byte of current input
;    AX=length of offensive input (<=4)
;  input okay and 1 byte out (subject to expansion)
;    no carry, Z, byte in AL, SI at next input
;    decrementing will be done after ret based on BX,
;      which is enough to cover possible expansion
;  input okay, no out ("!") or 3 byte out (0FEh, primitive)
;    no carry, NZ, output emitted if any, SI at next input
;    decrementing will be done after ret based on BX
got2in: dec	ax
	jnz	not9
;exclaim or foxfox
	cmp	cx,3	;exclaim/foxfox require 3 input bytes
	jb	needinp
	call	foxfox	;jumps to exclaim if ds:[si-1]=="!"
	jnc	dataok
;on error, may need up to 28 bytes out
dataerr:mov	bl,al
	add	bl,8
	call	rfshchk
	jc	rdwr
	call	errorout
	jmp	skip1
;
not9:	dec	ax
	jnz	not10
;tilde prefix case
	call	tilde
datachk:jc	dataerr
dataok: jnz	emited
	sub	cx,bx
	cmp	byte ptr ss:(pend3-baseb)[bp],ah
	je	putj	;jmp if no expand pending
	jmp	expand2
;
emited: sub	cx,bx
	jmp	short skip1
;quote prefix case
not10:	mov	al,byte ptr ds:[si]
	call	dectest
	jc	notdt
;timestamp or CRC token case. requires 20 bytes of input
	mov	bl,20
	call	rfshchk
	jc	rdwrx
	jz	needinp
notdt:	call	quote
	jmp	short datachk
;
;============================= SUBROUTINES =============================
;
;'hex' does the same 3 byte to 1 byte that XyWrite III+ does
;
hex	proc	near
	add	al,246-'0';C6h	;'0' to '9' to 246 to 255
	sub	al,256-10 ;F6h	;'0' to '9' to 0-9 w/no carry
	jnb	hex02		;at -'0', jmp if '0' to '9' in
	sub	al,7
	and	al,0Fh
hex02:	ret
hex	endp
;
;'hev' validates/translates base 32 digit (0-9,A-V)
;in:  AL=char
;out: if AL was '0'-'9','A'-'V', or 'a'-'v'
;	carry clear, AL=0-1Fh result
;     else carry set, AL=junk
hev	proc	near
	add	al,256-':';C6	;'0' to '9' to 246 to 255
	sub	al,256-10 ;F6	;'0' to '9' to 0-9 w/no carry
	jnb	hev02
	add	al,234-49 ;B9	;'a'-'v' to 234 to 255
	or	al,20h		;'A'-'V' to 234 to 255
	cmp	al,234	  ;EA
	jb	hev02
	sub	al,256-32 ;E0	;'A'-'V' to 10 to 31 w/no carry
hev02:	ret
hev	endp
;
;'realhex' maps '0'-'9','A'-F' to 00h-0Fh, gives carry otherwise.
;
realhex proc	near
	add	al,246-'0';C6h	;'0' to '9' to 246 to 255
	sub	al,256-10 ;F6h	;'0' to '9' to 0-9 w/no carry
	jnb	real02		;at -'0', jmp if '0' to '9' in
	cmp	al,17	  ;11h
	jb	real02		;jmp if 3Ah to 40h
	add	al,250-17 ;E9h	;'A'-'F' to 250 to 255
	sub	al,256-16 ;F0h	;'A'-'F' to 10 to 15 w/no carry
real02: ret
realhex endp
;
;'dectest': returns carry if AL not '0' to '9'
;
dectest proc	near
	cmp	al,'9'+1
	cmc
	jb	dect02
	cmp	al,'0'
dect02: ret
dectest endp
;
;'ucase' swaps AH,AL, then uppercases AL
;
ucase	proc	near
	xchg	ah,al
	cmp	al,'a'
	jb	uc02
	cmp	al,'z'+1
	jnb	uc02
	and	al,255-20h
uc02:	ret
ucase	endp
;
;'fixit' is part of the character reconstruction for bytes 2 and 3 of
;non-standard characters in XyWrite III type 3 byte encoded chars.
;
fixit	proc	near
	shr	ch,1
	jc	add7
	cmp	al,'0'
	jb	add7
	cmp	al,'9'+1
	jb	no7
add7:	add	al,7
no7:	ret
fixit	endp
;
;'expandx' writes a 3 byte encoding for the char in AL
expandx proc	near
	cmp	byte ptr ss:(pend3-baseb)[bp],2
	jb	xy3type 	;jmp if 0FFh,h,h type encode
;0FFh,0C0h,080h+char type encode
	add	ax,0c080h
	xchg	ah,al	;0Cx to AL, data byte to AH
	cmp	byte ptr ss:(pend3ex-baseb)[bp],bh
	je	expjoin ;jmp if no "!" correction
	add	al,byte ptr ss:(exclaimb-baseb)[bp]	;make correction
	jmp	short expjoin
;0FFh,h,h type encode (h=ASCII hex char)
xy3type:push	cx
	mov	cx,4	;CH=0,CL=4
	cmp	byte ptr ss:(pend3ex-baseb)[bp],ah
	mov	ah,33h	;gives std encoding if no "!" correction
	je	noexcl	;jmp if no "!" correction
	mov	ah,byte ptr ss:(exclaimb-baseb)[bp]	;correction data
	mov	ch,byte ptr ss:(exclaimn-baseb)[bp]	;correction flgs
;AH=chr2,chr3 high nibbles, AL=chr2,chr3 low nibbles
;want AH=chr2 high,low nibbles, AL=chr3 high,low nibbles
noexcl: ror	ax,cl	;shift nibbles to be swapped into AL
	ror	al,cl	;swap em
	rol	ax,cl	;and shift back
	call	fixit	;fix chr 3 in AL
	xchg	ah,al	;chr2 to AL, chr3 to AH
	call	fixit	;fix chr 2 in AL
	pop	cx
expjoin:push	ax
	mov	al,0FFh
	stosb		;0FFh prefix
	pop	ax
	stosw		;emit bytes 2 and 3
	xor	ax,ax
	mov	word ptr ss:(pend3w-basew)[bp],ax ;clr pending flgs
	ret
expandx endp
;
foxfox	proc	near
;cleared for 3 bytes in and 4 bytes out
	cmp	byte ptr ds:[si-1],'!'
	mov	ax,ds:[si]
	je	exclaim
;'foxfox' processes 0FFh encodes
;	mov	ax,ds:[si]	;already done above
	cmp	al,80h
	jb	xy3byte
;embedded function and IV XyWrite search type encodes passed as is
	dec	si
	movsb
	movsw
	xor	ax,ax
	mov	word ptr ss:(pend3w-basew)[bp],ax ;clear pendings
	test	sp,sp	;no carry, NZ
	ret
;XyWrite III+ 3 byte data encode
xy3byte:lodsw		;advance SI by 2 (AX was already loaded)
	call	hex	;decode high nibble in AL
	xchg	ah,al	;high nibble to AH
	call	hex	;decode low nibble in AL
;combine nibbles in AL, clear AH
	push	cx
	mov	cl,4
	shl	al,cl
	shr	ax,cl
	pop	cx
	cmp	ah,ah	;no carry, Z
	ret
foxfox	endp
;
;'exclaim' processes an exclaim packet
;
exclaim proc	near
;	mov	ax,ds:[si]	;already done in foxfox
	call	hev	;eval/chk byte 2 in AL
	jc	err3	;mov AX,3, ret w/carry (IN NEXT PROC)
	xchg	ah,al	;byte 2 to AH, byte 3 to AL
	call	hev	;eval/chk byte 3 in AL
	jc	err3	;mov AX,3, ret w/carry (IN NEXT PROC)
	push	cx
	mov	cx,1204h	;CH=12h,CL=4
;AH=chr2 high,low nibbles, AL=chr3 high,low nibbles
;want AH=chr2,chr3 high nibbles, AL=chr2,chr3 low nibbles
	ror	ax,cl	;shift nibbles to be swapped into AL
	ror	al,cl	;swap em
	rol	ax,cl	;and shift back
;high nibbles are 0 or 1. mov bit 4 to bit 1 in AH
	test	ah,ch
	jz	excl02
	xor	ah,ch
excl02: pop	cx
	mov	word ptr ss:(exclaimw-basew)[bp],ax ;save "!" data
	mov	byte ptr ss:(pend3ex-baseb)[bp],bl  ;set "!" flag
	xor	ax,ax	;no carry
	inc	si
	inc	si	;no carry, NZ return
	ret
exclaim endp
;
;'quote' processes quote prefixed packets. entry is down aways
;cleared for 2 bytes in and 4 out
;
quotex	proc	near
qumi:	mov	al,'_'
	ret
qusl:	mov	al,'%'
	ret
quvb:	mov	al,'!'
	ret
qupe:	mov	al,':'
	ret
quco:	mov	al,';'
	ret
quqm:	mov	al,'~'
	ret
qulq:	mov	al,"'"
	ret
;
quote:	lodsb
	cmp	al,'-'
	je	qumi		;'-', map to '_'
	cmp	al,'/'
	je	qusl		;'/', map to '%'
	cmp	al,'|'
	je	quvb		;'|', map to '!'
	cmp	al,'.'
	je	qupe		;'.', map to ':'
	cmp	al,','
	je	quco		;',', map to ';'
	cmp	al,'?'
	je	quqm		;'?', map to '~'
	cmp	al,'`'
	je	qulq		;'`', map to "'"
;
	cmp	al,'%'		;start CR-LF delimited comment?
	jne	notcmmt
	or	byte ptr ss:(skipctl-baseb)[bp],1
qunz:	test	sp,sp		;no carry, NZ
	ret
;
notcmmt:cmp	al,'^'		;'^', map to CRLF
	jne	notCRLF
	mov	ax,0A0Dh
	stosw
	xor	ax,ax
	mov	word ptr ss:(pend3w-basew)[bp],ax ;clr pendings
	jmp	short qunz
;
badfun1:mov	ax,cx
	ret
;
badfun2:dec	si
	dec	si
;'err3' is also branch point FROM PREVIOUS PROC
err3:	mov	ax,3
	stc
	ret
;
notCRLF:dec	si	;SI back to mainloop position
	call	dectest ;check if digit
	jnc	isnum	;branch if so (date/time or CRC)
;no recognized 2nd character. We must look in function code table
	cmp	cx,3
	jb	badfun1
	lodsw
	call	ucase		;AH to upper case
	call	ucase		;AL to upper case
	push	es
	push	cs
	pop	es
	push	di
	mov	di,offset verbs-offset s0
	push	cx
	mov	cx,verbcnt
	repne	scasw
	mov	ax,verbcnt-1
	pushf
	sub	ax,cx
	popf
	pop	cx
	pop	di
	pop	es
	jne	badfun2
	cmp	byte ptr ss:(pend3ex-baseb)[bp],bh ;'!' pfx?
	stc
	je	qu02	;jmp if not
	shr	byte ptr ss:(exclaimb-baseb)[bp],1 ;low bit fm pfx
qu02:	adc	ax,ax	;convert to offset
	xchg	ah,al	;byte 2 to AL, byte 3 to AH
	add	al,80h	;add in 80h trigger value
	push	ax
	mov	al,0FFh
	stosb		;emit 0FFh
	pop	ax
	stosw		;emit function code
	xor	ax,ax
	mov	word ptr ss:(pend3w-basew)[bp],ax ;clr pendings
	jmp	short qunz
;
;digit. date/time stamp. already cleared for 20 bytes of input. SI
;positioned as per immediately after main loop's lodsb. BX is set to 19
isnum:	push	si
	push	es
	push	cs
	pop	es
	push	di
	push	bx
	push	cx
	push	dx
	push	bp
	mov	bp,sp		;to pop down to reg restore area
;date stamp has format dd/dd/dddd dd:dd:dd or dd-dd-dddd dd:dd:dd
;set up DI to point to a string of the rqd separators, either
;"// ::" or "-- ::" (length 5)
	mov	ax," :"
	push	ax		;push byte 5 (":")
	xchg	ah,al
	push	ax		;push bytes 3,4 (" :")
;it could also be a CRC packet, which we've so far just let flow through
;the date stamp case to let the date stamp case do much of the work. We
;pick out the CRC packet case now
	cmp	ds:[si+1],al	;possible CRC packet?
	jne	sd00	;not CRC if 2nd char not blank
	or	di,word ptr cs:crc32dw	;any output yet
	jnz	sd00	;don't recognize CRC if output has occurred
	mov	ax,'mu'
	push	ax
	mov	ax,'sk'
	push	ax
	mov	ax,'ce'
	push	ax
	mov	ax,'hc'
	push	ax
	mov	ax," 0"
	push	ax
	mov	di,sp	;ES:DI now points at "0 checksum :: "
	mov	cx,11
	repe	cmpsb
	stc		;if error
	jne	ctok06	;jmp w/carry if not "0 checksum "
	mov	cl,8
ctok02: lodsb
	call	realhex
	jc	ctok06	;jmp w/carry if not hex digit
	push	cx
	mov	cl,4
ctok04: add	bx,bx
	adc	dx,dx
	loop	ctok04
	pop	cx
	add	bl,al	;clears carry
	loop	ctok02
;looks good, save desired CRC and start CRC accumulator
	call	cssetup
ctok06: jmp	ltok02
;continue with date token
sd00:	mov	al,'-'		;tentative value for bytes 1,2
	cmp	ds:[si+2],al	;check if okay
	je	isminus 	;branch if so	    bp   <--bp
	mov	al,'/'		;use '/' otherwise  	12   <--bp+2
isminus:mov	ah,al		;2 rqd		    	31
	push	ax		;push bytes 1,2     	2099
	mov	di,sp		;point DI at string 	23
	mov	ax,59		;		    	59
	push	ax		;push seconds limit 	59
	push	ax		;push minutes limit 	"--" <-es:di
	mov	al,23		;		    	" :"
	push	ax		;push hours limit   	": "
	mov	ax,2099 	;		    >saved bp
	push	ax		;push year limit	saved dx
	mov	ax,31		;			saved cx
	push	ax		;push day limit 	saved bx
	mov	al,12		;			saved di
	push	ax		;push month limit	saved es
	push	bp		;			saved si
	mov	bp,sp		;			 
;stack now looks like 
	mov	cx,0AEA8h	;1010 1110 1010 1000
;AH=0,BX=num_build,CX=ctl bits,DI=sep ptr,SI=in ptr,BP=test/out ptr
sd02:	xor	bx,bx
sd04:	lodsb
	sub	al,'0'
	cmp	al,10
	jnb	sd08
	xchg	bx,ax	;AX=num_build, BX=nxt chr
	mov	dx,10
	mul	dx	;num_build time 10
	xchg	bx,ax	;BX=num_build, AX=nxt chr
	add	bx,ax	;BX=includes new digit
sd06:	add	cx,cx	;what's next?
	jc	sd04	;carry: another digit
	xchg	bx,word ptr ss:[bp+2]	;save num_build, get limit
	cmp	bx,word ptr ss:[bp+2]	;compare limit with num_build
	jb	sd08	;jmp w/carry if limit below num_build
	inc	bp
	inc	bp	;prepare for next item
	jcxz	sd10	;jmp w/no carry if done
	cmpsb		;check next sep char
	je	sd02	;jmp if okay
sd08:	stc		;indicate error
sd10:	pop	bp
	jc	ltok02	;jmp w/carry if error
	pop	ax
	mov	ch,al	;month to CH
	pop	ax
	mov	cl,al	;day to CL
	pop	ax	;year to AX
	sub	ax,1956 ;reorigin year
	jbe	ltok02	;jmp w/carry if too low
	push	ax	;save year
	push	cx	;save mo/day
	call	toint	;map date map to integer
; ; ;	call	fromint ;map back
;;"toint" is accepting of small input errors and does kind of what one
;would expect. For example, it would give about the same result for
;00/15/2007 as it would give for 12/15/2006, or the same result for
;02/29/2005 as for 03/01/2005. "fromint," always maps its input back to
;a *valid* date. If the input to "toint" was valid, therefore, "fromint"
;will produce exactly the same date as we started with, but if it was
;invalid, it will not. We use this to weed all all possible invalid
;dates (that haven't already been weeded out by gross upper bounds
;checks).
	pop	dx	;get original mo/day
	pop	bx	;get original year
	cmp	ax,bx
	stc		;bad date if mapping changed year
	jne	ltok02	;jmp w/carry if year changed
	cmp	cx,dx
	stc		;bad date if mapping change mo/day
	jne	ltok02	;jmp w/carry if mo/day changed
	sub	ax,1980-1956	;origin to 1980, per DOS
	jb	ltok02	;jmp w/carry if too low
;AX=year-1980 (0-119, 7 bits), DH=month (1-12, 4 bits)
;DL=day (1-31, 5 bits)
	mov	cl,4	;4 bits for month
	shl	ax,cl	;make room for month
	add	al,dh	;add in month
	inc	cx	;5 bits for day
	shl	ax,cl	;make room for day
	add	al,dl	;add in day
	pop	bx	;hour
	inc	cx	;6 bits for minutes
	shl	bx,cl	;make room for minutes
	pop	dx	;minutes
	add	bl,dl	;add in minutes
	dec	cx	;5 bits for seconds
	shl	bx,cl	;make room for seconds
	pop	dx	;seconds
	shr	dx,1	;drop low bit of seconds
	add	bl,dl	;add in seconds/2, clear carry
	mov	word ptr cs:datedx,ax
	mov	word ptr cs:datecx,bx
ltok02: 		;errors come here with carry set
	mov	sp,bp	;pop stack down to reg save area
	pop	bp
	pop	dx
	pop	cx
	pop	bx
	pop	di
	pop	es
	pop	ax	;saved SI value
	jc	ltok04
	xor	ax,ax
	test	sp,sp	;no carry, NZ return
	ret
;
ltok04: xchg	si,ax	;SI back to before scan
	mov	ax,20	;20 bytes in failed parse
	ret		;ret w/carry
quotex	endp
;
;'toint' maps valid dates onto a contiguous integer space, from 3/1/1956
;(=123) thru 2/28/2100(=52717)
;
;in:	CH: month (1-12)
;	CL: day of month (1-31)
;	AX: year-1956 (0-120)
;out:	AX: number of days since 10/30/1995
;	BX,CX,DX: destroyed
;
toint	proc near
	cmp	ch,3		;check if March or later
	jnb	aftfeb		;jmp if after Feb
	dec	ax		;decrement year
	add	ch,12		;Jan, Feb=months 13,14 of prev year
aftfeb: mov	bx,1461 	;=365.25*4
	mul	bx
	mov	bx,4
	div	bx
	push	ax		;component due to year
	mov	ax,153*256	;AH=153, AL=0
	xchg	al,ch		;AL=month, CX=day
	inc	ax
	mul	ah
	xor	dx,dx
	inc	bx		;=5
	div	bx		;AX=component due to month
	add	cx,ax		;add month component to day
	pop	ax
	add	ax,cx		;add year component
;(AX mod 7 at this point would give 0-6=Sun though Sat)
; ; ;	ret
;
;'fromint' maps contiguous integer space into valid dates, from
;123 (=3/1/1956) thru 52717 (=2/28/2100). Transform is the inverse of
;that done by 'toint'
;
;in:	AX: number of days since 10/30/1955
;out:	CH: month (1-12)
;	CL: day of month (1-31)
;	AX: year-1956
;	BX,DX: destroyed
;
; ; ;fromint proc    near
	mov	cx,ax
	mov	bx,4
	mul	bx
	sub	ax,489		;adjust for desired bdy effects
	sbb	dx,0
	mov	bx,1461 	;=365.25*4
	div	bx
	push	ax		;AX=year origin 1956, -1 if Jan,Feb
	mul	bx
	mov	bx,4
	div	bx		;AX=integer component due to yr
	sub	cx,ax		;CX=day in year
	mov	ax,cx
	inc	bx		;=5
	mul	bx
	dec	ax
	mov	dl,153		;=30.6*5
	div	dl
	push	ax		;AL=month+1, with Jan,Feb = 13+1,14+1
	mul	dl
	xor	dx,dx
	div	bx		;AX=int component due to month
	sub	cx,ax		;CX=day in month
	pop	ax		;month+1
	dec	ax		;month
	mov	ch,al		;CH=month, CL=day
	cmp	al,13
	pop	ax		;year (origin 1956)
	jb	mthok		;jump if not Jan or Feb
	inc	ax		;Jan or Feb, adjust year up
	sub	ch,12		;..and month down
mthok:	ret
; ; ;fromint endp
toint	endp
;
;'tilde' processes tilde prefixed packets.
;cleared for 2 bytes in and 4 out
;
tilde	proc	near
	lodsb
	cmp	al,'@'
	jb	belowat
	cmp	al,'_'+1
	jb	isctl
	cmp	al,'{'		;'{', map to '' (0EEh)
	je	tilb
;error exit. set length, put SI back at byte 2 of packet
tildeb2:dec	si
	mov	al,2
	stc
	ret
;
isctl:	sub	al,'@'
	cmp	al,al	;clear carry, Z
	ret
;
tilb:	mov	al,0EEh 	;''
	ret
tilg:	mov	al,0AEh 	;left guillemet
	ret
tirg:	mov	al,0AFh 	;right guillemet
	ret
tieq:	mov	al,0F0h 	;'=', map to '' (0F0h
	ret
tisl:	or	byte ptr ss:(skipctl-baseb)[bp],1
	jmp	short tinz
;
belowat:call	dectest 	;test if digit
	jnc	tildeddd
	cmp	al,'<'
	je	tilg		;'<', map to l-guillemet (0AEh)
	cmp	al,'>'
	je	tirg		;'>', map to r-guillemet (0AFh)
	cmp	al,'='
	je	tieq
	cmp	al,'/'		;start CR-LF delimited comment?
	je	tisl		;jmp if so
	cmp	al,'#'		;start r-guillemet delimited comment?
	jne	tildeb2 	;jmp if not
	add	byte ptr ss:(skipctl-baseb)[bp],2 ;start cmt skip
tinz:	test	sp,sp		;no carry, NZ
	ret
;
tilded3:dec	si
tilded2:dec	si
	mov	al,4
tilded1:dec	si
	stc
	ret
;
tildeddd:cmp	cx,4
	mov	al,cl		;set length of bad (if bad)
	jb	tilded1 	;jmp if not enough input
	lodsb
	call	dectest
	jc	tilded2
	lodsb
	call	dectest
	jc	tilded3
;three decimal digits verified
	sub	si,3		;back to first digit
	xor	ax,ax		;clr number build
	push	bx
	push	cx
	mov	bh,10		;multiplier
	mov	cx,3		;loop count
tidddlp:xchg	bx,ax
	lodsb
	sub	al,'0'
	xchg	bx,ax		;bl=digit-'0' (0-9)
	mul	bh		;prv times 10 to AX
	add	al,bl		;add in new digit
	adc	ah,0		;propagate carry
	loop	tidddlp
	pop	cx
	pop	bx
	test	ah,ah		;test if <256
	jz	tiret		;jmp if so - no carry, Z
;0FEh prefix encoding required
	sub	ax,256		;adjust per XY IV coding
	push	ax
	mov	al,0FEh
	stosb
	pop	ax
	stosw
	xor	ax,ax
	mov	word ptr ss:(pend3w-basew)[bp],ax ;clr pendings
	test	sp,sp		;no carry, NZ
tiret:	ret
tilde	endp
;
errorout proc	near
	sub	cx,bx
	dec	si
	push	cx
	xchg	cx,ax
	mov	ax,'['*101h
	mov	byte ptr ss:(errflag-baseb)[bp],al
	stosw
	stosw
cpylp:	lodsb
	cmp	al,0FDh
	jb	cpychok
	mov	al,'?'
cpychok:stosb
	loop	cpylp
	mov	ax,']'*101h
	stosw
	stosw
	xor	ax,ax
	pop	cx
	ret
errorout endp
;
;CX=count, DS:DX=data
crc32out proc	near
	jcxz	nocrc		;jmp if nothing to be written
	mov	word ptr cs:crc32dw,cx ;a write has been done
	cmp	byte ptr cs:crc32sw,0 ;are we doing CRC?
	je	nocrc		;jmp if not
IF HOOKS
	call	crcdebug
endIF
	push	di
	push	si
	push	dx
	push	ax
	push	bx
	push	cx
	mov	di,cx		;count
	mov	si,dx		;start address
	mov	ax,word ptr cs:crc32d
	mov	dx,word ptr cs:crc32d+2
; ;	call	crc32	;proc included inline
; ;crc32	proc	near
;In:	DX:AX		CRC so far
;	DS:SI		buffer ptr
;	DI		count
;	crctab,crctabh	filled in
;Out:	DX:AX		updated
;	BX,CX,SI,DI	destroyed
;	direction	fwd
; ;	cld
	not	ax
	not	dx
	shr	di,1
	inc	di
	jnc	cr06
	mov	cx,dx
	jmp	short cr04
;
cr02:	mov	bl,al
	lodsb
	xor	bl,al
	mov	al,ah
	shl	bx,1
	mov	ah,dl
	mov	cx,word ptr cs:crctabh[bx]
	xor	ax,word ptr cs:crctab[bx]
	xor	cl,dh
cr04:	mov	bh,0
	mov	bl,al
	lodsb
	xor	bl,al
	mov	al,ah
	shl	bx,1
	mov	ah,cl
	mov	dx,word ptr cs:crctabh[bx]
	xor	ax,word ptr cs:crctab[bx]
	xor	dl,ch
cr06:	dec	di
	mov	bh,0
	jnz	cr02
cr08:	not	ax
	not	dx
; ;	ret
; ;crc32	endp
	mov	word ptr cs:crc32d,ax
	mov	word ptr cs:crc32d+2,dx
	pop	cx
	pop	bx
	pop	ax
	pop	dx
	pop	si
	pop	di
nocrc:	ret
crc32out endp
;
;
;'cssetup' builds the tables we need to generate a CRC32 checksum, and
;initiates CRC32 computations
cssetup proc	near
	push	ds
	push	si
	push	cs
	pop	ds
	assume	ds:_TEXT
	mov	word ptr ds:crc32tk,bx
	mov	word ptr ds:crc32tk+2,dx
	inc	byte ptr ds:crc32sw
	xor	bx,bx
tc02:	xor	dx,dx		;accumlator high
	mov	di,bx		;accumlator low
	mov	cx,8		;count
	lea	si,ds:[bx+di]	;offset into table(s)
tc04:	shr	dx,1		;shift accum hi right 1, low bit into carry
	rcr	di,1		;shift accum lo right 1, carry into high
				;bit, and low bit into carry
	jnc	tc06		;jmp if low bit was zero
	xor	dx,0EDB8h
	xor	di,08320h
;
;Source of above the above DX:DI constant
;
;The polynomial for CRC 32 is
;  32  26  23  22  16  12  11  10  8  7  5  4  2  1  0	(<== exponents)
; x  +x  +x  +x  +x  +x  +x  +x  +x +x +x +x +x +x +x
;
;The above constant (XOR'ed to DX:DI) is 0EDB88320h. In binary, this is
;1 1 1 0 1 1 0 1 1 0 1  1  1 0 0 0 1 0 0 0 0 0 1  1 0 0 1 0 0 0 0 0  (binary)
;0   2   4   6   8   10    12  14  16  18  20  22   24  26  28  30   (bit ..
;  1   3   5   7   9    11   13  15  17  19  21   23  25  27  29  31 ..numbers)
;0 1 2   4 5   7 8   10 11 12      16          22 23    26 <= (selected bit
;	bit numbers (the x-to-the-32nd term is implicit))
;The selected bits match the exponents of the polynomial, representing
;feedback (XOR) for the corresponding bits.
;
tc06:	loop	tc04
	mov	word ptr ds:crctab[si],di
	mov	word ptr ds:crctabh[si],dx
	inc	bx
	test	bh,bh
	jz	tc02
	pop	si
	pop	ds
	ret
cssetup endp
	assume	ds:nothing
;
	assume	ds:_TEXT
warnings proc	near
	cmp	byte ptr ds:crc32sw,cl
	je	wa02
	mov	ax,word ptr ds:crc32tk
	mov	dx,word ptr ds:crc32tk+2
	xor	ax,word ptr ds:crc32d
	xor	dx,word ptr ds:crc32d+2
	or	ax,dx
	or	al,ah
	mov	cs:crc32err,al
wa02:	mov	ch,ds:errflag
	mov	dx,offset errmsg
	call	emsg
	mov	ch,ds:crc32err
	mov	dx,offset crcmsg
	call	emsg
	ret
warnings endp
;
errmsg	db	7,"WARNING: input file had syntax errors",13,10,'$'
;
crcmsg	db	7,"WARNING: output file failed CRC32 check",13,10,'$'
;
usemsg	db	'XYDEC v0.96 (c) Wally Bass 2009. '
	db	'Released to the Public Domain.',13,10,10
	db	'Usage: XYDEC file_in file_out',13,10,10
	db	"Specify filename of '.' for std input or std output"
	db	13,10,10
	db	'Decodes a XyWrite III or IV (or NotaBene)'
	db	' XPL program or text file that',13,10
	db	'has been encoded with XYENC. Output is checked'
	db	' with CRC32 if input file',13,10
	db	'contains checksum token.',13,10,10
	db	'If an input syntax error occurs, the offending '
	db	'input is passed unchanged',13,10
	db	"to the output file, but is bracketed with '[[[[' "
	db	"and ']]]]' characters.",13,10
	db	'To find errors, search for these brackets in the '
	db	'output file.',13,10,10,'$'
;
IF HOOKS
;
;a call to 'debug1" is the very first thing the the XYENC module does.
;This makes it easy to find the following with a debugger
	db	'start'
debug1	proc	near
	hookcode
debug1	endp
;'debug2' is called right before initial entry into our main loop
	db	'mainlp'
debug2	proc	near
	hookcode
debug2	endp
;'crcdebug' is called when we are about do process data for CRC32
	db	'crc32'
crcdebug proc	near
	hookcode
crcdebug endp
endIF
;
; ;	dobuffer		;we do our own version
t = (offset s0+8000h-$) mod 16
IF t
	db	t dup(0)	;to paragraph boundary for buffer
endIF
;
crctab	equ	this word	;filled in by crcbld subr
;
crctabh equ	this word+512	;filled in by crcbld subr
;
buffer	equ	this word+1024
t = (offset s0+8100h-$) mod 512
IF t
	db	t dup(0)	;pad to mult of 512 for faster loading
endIF
;
_TEXT	ends
	end	start
